<?php
/*
 * Corllete Lab Widgets - Theme Stream
 *
 * Copyright (C) 2006-2009 Corllete ltd (clabteam.com)
 * Support and updates at http://www.free-source.net/
 * Released under the terms and conditions of the
 * GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
 *
 * Theme Stream Widget Main Class
 *
 * $Id: theme_stream_class.php 565 2009-06-25 12:56:07Z sonice $
*/

if (!defined("e107_INIT")) exit;

/**
 * Blank Widget Class
 * 
 * Following constants are available after class initialization
 * CLW_ABS_BLANK - absolute path to your widget (domain not included)
 * CLW_HTTP_BLANK - full path to your widget (http://yourdomain.com included)
 * CLW_REL_BLANK - relative path to your widget
 * CLW_SC_BLANK - Shortcode path to your widget ( e.g. {e_PLUGIN}cl_widgets/widgets/blank/ ) 
 *
 */
class clw_theme_stream_class extends clw_widget_abstract 
{
    function use_jslib() 
    {
        //not needed really - loaded by default
        return array ();
    }
    function e_jslib() 
    {
        return array();
    }
    function e_bb() 
    {
		
    }
    function run_sc($name, $parms = array()) 
    {

	}
    function run_bb($name, $text='', $parms = '') 
    {

	}
	
    function e_meta($type) {
		if ($type == 'pre_lib') return '';
		
		$TH_SITE_W 		= $this->getPref('theme_siteWidth');
		$TH_SITE_MET 	= $this->getPref('theme_siteWidthMetric');
		$TH_LEFT_COL_W 	= $this->getPref('theme_leftColWidth');
		$TH_RIGHT_COL_W = $this->getPref('theme_rightColWidth');
		
		
		$ret = '
			<style type="text/css">
				.view-area			{ width: '.$TH_SITE_W.$TH_SITE_MET.';}
				.col-left			{ width: '.$TH_LEFT_COL_W.'px;}
				.col-main-center	{ margin-left: '.(($this->streamCheckMenu(1)) ? ($TH_LEFT_COL_W + 5) : '0').'px; }
				.col-right			{ width: '.$TH_RIGHT_COL_W.'px; }
				.col-center			{ margin-right: '.(($this->streamCheckMenu(2)) ? ($TH_RIGHT_COL_W + 15) : '0').'px; }
				.box-center			{ width: '.($TH_LEFT_COL_W - 30).'px;}
			</style>
		';
	
		return $ret; 
	}
	
    function e_module()
    {
    	//do something in the early dawn
    }
	
	
	
	function streamCheckMenu($area){
		global $eMenuList,$d;
		
		foreach($eMenuList[$area] as $row)
		{
			$show_menu = TRUE;
			
			if($row['menu_pages']) {
				
				list($listtype,$listpages) = explode("-",$row['menu_pages']);
				$pagelist = explode("|",$listpages);
				$check_url = e_SELF.(e_QUERY ? "?".e_QUERY : '');
		
				if($listtype == '1')  //show menu
				{
					$show_menu = FALSE;
					foreach($pagelist as $p)
					{
						if(substr($p, -1) == '!')
						{
							$p = substr($p, 0, -1);
							if(substr($check_url, strlen($p)*-1) == $p)
							{
								$show_menu = TRUE;
							}
						}
						else 
						{
							if(strpos($check_url,$p) !== FALSE)
							{
								$show_menu = TRUE;
							}
						}
					}
				}
				elseif($listtype == '2') //hide menu
				{
					$show_menu = TRUE;
					foreach($pagelist as $p) {
						if(substr($p, -1) == '!')
						{
							$p = substr($p, 0, -1);
							if(substr($check_url, strlen($p)*-1) == $p)
							{
								$show_menu = FALSE;
							}
						}
						else 
						{
							if(strpos($check_url, $p) !== FALSE)
							{
								$show_menu = FALSE;
							}
						}
					}
				}
			}
		}
			 
		
		$th_listtype = '';
		$th_pagelist = '';
				
				
		switch($area) 
		{
			case "1":
				$th_listtype = $this -> getPref('theme_leftCol');
				if ($this -> getPref('theme_leftColPages') != '') $th_pagelist = explode("|", $this -> getPref('theme_leftColPages'));
			break;
			case "2":
				$th_listtype = $this -> getPref('theme_rightCol');
				if ($this -> getPref('theme_rightColPages') != '') $th_pagelist = explode("|", $this -> getPref('theme_rightColPages'));
			break;
		}
				
		$th_check_url = e_SELF.(e_QUERY ? "?".e_QUERY : '');
		
		
		
		if ($th_listtype == '0') //hide column
		{
			
			if ($th_pagelist) {
				$show_menu = TRUE;
				foreach($th_pagelist as $a) {
					
					if(substr($a, -1) == '!')
					{
						$a = substr($a, 0, -1);
						if(substr($th_check_url, strlen($a)*-1) == $a)
						{
							$show_menu = FALSE;
						}
					}
					else 
					{
						if(strpos($th_check_url, $a) !== FALSE)
						{
							$show_menu = FALSE;
						}
					}
				}
			} else {
				$show_menu = FALSE;
			}
		} 
		elseif($th_listtype == '1')  //show column
		{
			if ($th_pagelist) {
				$show_menu = FALSE;
				foreach($th_pagelist as $a)
				{
					if(substr($a, -1) == '!')
					{
						$a = substr($a, 0, -1);
						if(substr($th_check_url, strlen($a)*-1) == $a)
						{
							$show_menu = TRUE;
						}
					}
					else 
					{
						if(strpos($th_check_url,$a) !== FALSE)
						{
							$show_menu = TRUE;
						}
					}
				}
			} else {
				$show_menu = TRUE;
			}
		}

		if ($show_menu) {
			return TRUE;
		}

	}
}